package stanze;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import ftcomputing.FishThread;
import ftcomputing.JavaFish;
import javax.swing.border.*;

/**
 * berschrift:  Stanzmaschine mit Transportband
 * Beschreibung: Freier Nachbau des fischertechnik Trainingsmodells No. 51 663.
 *               Bentigt die Klasse JavaFish, javaFish.DLL und umFish20.DLL
 * Copyright:    Copyright (c) 2002 Ulrich Mller
 * Organisation: U. Mller, D-33100 Paderborn, Lange Wenne 18
 * @author Ulrich Mller
 * @version 1.0
 */

public class StanzForm extends JFrame {
  JPanel contentPane;
  JButton cmdAction = new JButton();
  JButton cmdEnde = new JButton();
  JLabel lblStatus = new JLabel();

  JavaFish ft = new JavaFish();
  Stempel stempel;

  // --- Interface-Belegung -------------------------------------------------

  static final int mBand   = 1, cbVor   = 1, cbRuck  = 2,
                   ePhotoV = 1, ePhotoS = 2, mLampen = 3,
                   mStanze = 2, eOben   = 3, eUnten  = 4, csAb = 1, csAuf = 2;

  /**Den Frame konstruieren*/
  public StanzForm() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Initialisierung der Komponenten*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(StanzForm.class.getResource("[Ihr Symbol]")));
    contentPane = (JPanel) this.getContentPane();
    titledBorder1 = new TitledBorder("");
    cmdAction.setText("START");
    cmdAction.setBounds(new Rectangle(286, 232, 86, 29));
    cmdAction.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cmdAction_actionPerformed(e);
      }
    });
    this.setResizable(false);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Stanzmaschine mit Transportband No. 51 663");
    contentPane.setLayout(null);
    cmdEnde.setBounds(new Rectangle(286, 194, 86, 29));
    cmdEnde.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        cmdEnde_actionPerformed(e);
      }
    });
    cmdEnde.setText("ENDE");
    lblStatus.setBorder(BorderFactory.createLoweredBevelBorder());
    lblStatus.setHorizontalAlignment(SwingConstants.CENTER);
    lblStatus.setText("START/ENDE");
    lblStatus.setBounds(new Rectangle(33, 47, 332, 26));
    lblNo.setFont(new java.awt.Font("Dialog", 1, 32));
    lblNo.setText("51 663");
    lblNo.setBounds(new Rectangle(41, 196, 109, 54));
    contentPane.add(cmdAction, null);
    contentPane.add(cmdEnde, null);
    contentPane.add(lblStatus, null);
    contentPane.add(lblNo, null);
  }
  /**berschrieben, so dass eine Beendigung beim Schlieen des Fensters mglich ist.*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  // ---- Thread fr den Modellbetrieb -------------------------------------

  public class Stempel extends FishThread {
    public Stempel(JavaFish ft){
      super(ft);
    }
    public void run(){
      ft.clearMotors();
      ft.setMotor(mStanze, csAuf);
      ft.waitForInput(eOben);
      ft.setMotor(mStanze, ft.OFF);
      ft.setMotor(mLampen, ft.ON);
      do {
        lblStatus.setText("Wartet");
        ft.waitForLow(ePhotoV);
        ft.pause(500);
        lblStatus.setText("Zur Stanze");
        ft.setMotor(mBand, cbVor);
        ft.waitForLow(ePhotoS);
        ft.setMotor(mBand, ft.OFF);

        lblStatus.setText("Stanzen");
        ft.setMotor(mStanze, csAb);
        ft.waitForInput(eUnten);
        ft.setMotor(mStanze, ft.OFF);
        ft.pause(1000);
        ft.setMotor(mStanze, csAuf);
        ft.waitForInput(eOben);
        ft.setMotor(mStanze, ft.OFF);

        lblStatus.setText("Zurck");
        ft.setMotor(mBand, cbRuck);
        ft.waitForInput(ePhotoV, false);
        ft.pause(300);
        ft.setMotor(mBand, ft.OFF);
      } while (!ft.finish());
      ft.closeInterface();
      lblStatus.setText("START / ENDE");
      lblNo.setForeground(Color.black);
      cmdEnde.setText("ENDE");
      cmdAction.setEnabled(true);
    }
  }

  // --- Beenden des Modellbetriebs bei Button = HALT,
  //     Beenden des Programms bei Button = ENDE ----------------------------

  void cmdEnde_actionPerformed(ActionEvent e) {
    if(cmdEnde.getText() == "ENDE") System.exit(0);
    else {
      ft.emergencyHalt = true;
      try{stempel.join();} catch(InterruptedException ex){}
    }
  }

  // --- Steuern des Modellbetriebs --------------------------------------

  void cmdAction_actionPerformed(ActionEvent e) {
    int res;

    // -------------------------------------------- Open COM1 ------------
    if(ft.openInterface("COM1") == ft.FT_ERROR) {
      lblStatus.setText("InterfaceProblem");
      lblNo.setForeground(Color.red);
      return;
    };
    stempel = new Stempel(ft);
    stempel.start();

    cmdAction.setEnabled(false);
    lblNo.setForeground(Color.green);
    cmdEnde.setText("HALT");
    cmdEnde.requestFocus();
  }
  TitledBorder titledBorder1;
  JLabel lblNo = new JLabel();
}